PROGRAM TST04G;

DEVICE = mega8;

{$I mega8_Register.INC}


CONST

  // TaktFrequenz in KHz
  TaktFrequenz : WORD = 1000;


VAR


  LSP_D0[PortB,0] : bit;      // Ausgang - Lautsprecher Bit 0


  TAST_SW_SHIFT[PINB,1] : bit;      // Eingang - Tastatur SHIFT
  TAST_SW_CTRL[PINB,2] : bit;       // Eingang - Tastatur CTRL

  TAST_R0[PIND,0] : bit;        // Eingang - Tastatur Zeile 00
  TAST_R1[PIND,1] : bit;        // Eingang - Tastatur Zeile 01
  TAST_R2[PIND,2] : bit;        // Eingang - Tastatur Zeile 02
  TAST_R3[PIND,3] : bit;        // Eingang - Tastatur Zeile 03
  TAST_R4[PIND,4] : bit;        // Eingang - Tastatur Zeile 04


  SHIFT_CLOCK[PortD,5] : bit; // Ausgang - 74595 - SHIFT_CLOCK
  LATCH_CLOCK[PortD,6] : bit; // Ausgang - 74595 - LATCH_CLOCK
  SERIAL_DATA[PortD,7] : bit; // Ausgang - 74595 - SERIAL_DATA

  Status_LED_SHIFT_GN1, Status_LED_SHIFT_GN2,
  Status_LED_CTRL_BL1,   Status_LED_CTRL_BL2   : Boolean;



{$I SYSTEM.INC}

{$I TON.INC}

{$I KBD.INC}

{$I ITP3_CLI_PORT.INC}
{$I ITP3_CLI_PRG.INC}






// *** INITIALISIERUNG ***


procedure InitPorts;
begin

{
  LSP_D0[PortB,0] : bit;      // Ausgang - Lautsprecher Bit 0
  TAST_SW_SHIFT[PINB,1] : bit;      // Eingang - Tastatur SHIFT
  TAST_SW_CTRL[PINB,2] : bit;       // Eingang - Tastatur CTRL
}
  //       EEEEEEEA
  DDRB:=  %00000001;

  // PORT B Voreinstellungen
  PORTB:= %00000000;



{
  TAST_R0...TAST_R4 - Eingang
  SHIFT_CLOCK[PortD,5] : bit; // Ausgang - 74595 - SHIFT_CLOCK
  LATCH_CLOCK[PortD,6] : bit; // Ausgang - 74595 - LATCH_CLOCK
  SERIAL_DATA[PortD,7] : bit; // Ausgang - 74595 - SERIAL_DATA
}
  //       AAAEEEEE
  DDRD:=  %11100000;

  // PORT D Voreinstellungen
  PortD:= %00000000;



end InitPorts;



PROCEDURE wait_ms2(Zeit : Word);
VAR
  w1 : Word;
  w2 : Word;
BEGIN
  for w1:=1 to Zeit do
    for w2:=1 to 10 do
    endfor;
  endfor;
END wait_ms2;




PROCEDURE ton(Frq, Dauer : Word);
var
  w0 : Word;
BEGIN

  for w0:=1 to Dauer do

  ClearBit(LSP_D0);
  wait_ms2(Frq);

  SetBit(LSP_D0);
  wait_ms2(Frq);

  ClearBit(LSP_D0);
  wait_ms2(Frq);

  SetBit(LSP_D0);
  wait_ms2(Frq);

  ClearBit(LSP_D0);
  wait_ms2(Frq);

  SetBit(LSP_D0);
  wait_ms2(Frq);

  endfor;

END ton;




PROCEDURE ton2;
BEGIN
    WD_Word:=$0000;
    Write_Data_Word;


    ton(10,20);
    wait_ms(20);

    ton(80,20);
    wait_ms(20);


    ton(60,20);
    wait_ms(20);

    ton(30,20);
    wait_ms(20);

    WD_Word:=$FFFF;
    Write_Data_Word;


    ton(20,10);
    ton(25,10);
    ton(22,10);
    ton(18,10);


    WD_Word:=$0000;
    Write_Data_Word;

END ton2;




PROCEDURE ton3;
BEGIN

  WD_Word:=$FFFF;
  Write_Data_Word;

  ton(20,5);
  ton(25,5);
  ton(22,5);
  ton(18,5);

  WD_Word:=$0000;
  Write_Data_Word;

END ton3;







BEGIN


  InitPorts;

  KBD_Init;

  ITP3_Client_Init;

  ton3;




  loop

    Tastatur_lesen;
    ITP3_Server_Abfrage;

    if BitLow(TAST_SW_SHIFT) then
      SHIFT_ist_aktiv:=true;
      Status_LED_SHIFT_GN1:=true;
      Status_LED_SHIFT_GN2:=true;
    else
      SHIFT_ist_aktiv:=false;
      Status_LED_SHIFT_GN1:=false;
      Status_LED_SHIFT_GN2:=false;
    endif;


    if BitLow(TAST_SW_CTRL) then
      CTRL_ist_aktiv:=true;
      Status_LED_CTRL_BL1:=true;
      Status_LED_CTRL_BL2:=true;
    else
      CTRL_ist_aktiv:=false;
      Status_LED_CTRL_BL1:=false;
      Status_LED_CTRL_BL2:=false;
    endif;

    Anzeige_Status_LEDs;

  endloop;




END TST04G.
